scala.tools.nsc.typechecker

# Contexts

###
Related Doc: package typechecker

#### trait Contexts extends AnyRef

Self Type
  Analyzer
Source
  Contexts.scala
Version

  1.0

Linear Supertypes
AnyRef, Any
Known Subclasses
Analyzer, Duplicator, Duplicators, Erasure, SpecializationDuplicator, TreeCheckers, erasure, treeChecker
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Contexts
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1. #### class Context extends AnyRef

   A motley collection of the state and loosely associated behaviour of the type checker.

   A motley collection of the state and loosely associated behaviour of the type checker. Each `Typer` has an associated context, and as it descends into the tree new `(Typer, Context)` pairs are spawned.

   Meet the crew; first the state:

   - A tree, symbol, and scope representing the focus of the typechecker
   - An enclosing context, `outer`.
   - The current compilation unit.
   - A variety of bits that track the current error reporting policy (more on this later); whether or not implicits/macros are enabled, whether we are in a self or super call or in a constructor suffix. These are represented as bits in the mask `contextMode`.
   - Some odds and ends: undetermined type parameters of the current line of type inference; contextual augmentation for error messages, tracking of the nesting depth.

   And behaviour:

   - The central point for issuing errors and warnings from the typechecker, with a means to buffer these for use in 'silent' type checking, when some recovery might be possible.
   - `Context` is something of a Zipper for the tree were are typechecking: it `enclosingContextChain` is the path back to the root. This is exactly what we need to resolve names (`lookupSymbol`) and to collect in-scope implicit definitions (`implicitss`) Supporting these are `imports`, which represents all `Import` trees in in the enclosing context chain.
   - In a similar vein, we can assess accessibility (`isAccessible`.)

   More on error buffering: When are type errors recoverable? In quite a few places, it turns out. Some examples: trying to type an application with/without the expected type, or with/without implicit views enabled. This is usually mediated by `Typer.silent`, `Inferencer#tryTwice`.

   Initially, starting from the `typer` phase, the contexts either buffer or report errors; afterwards errors are thrown. This is configured in `rootContext`. Additionally, more fine grained control is needed based on the kind of error; ambiguity errors are often suppressed during exploratory typing, such as determining whether `a == b` in an argument position is an assignment or a named argument, when `Inferencer#isApplicableSafe` type checks applications with and without an expected type, or when `Typer#tryTypedApply` tries to fit arguments to a function type with/without implicit views.

   When the error policies entail error/warning buffering, the mutable ReportBuffer records everything that is issued. It is important to note, that child Contexts created with `make` "inherit" the very same `ReportBuffer` instance, whereas children spawned through `makeSilent` receive a separate, fresh buffer.

2. #### abstract class ContextReporter extends Reporter

   A reporter for use during type checking.

   A reporter for use during type checking. It has multiple modes for handling errors.

   The default (immediate mode) is to send the error to the global reporter. When switched into buffering mode via makeBuffering, errors and warnings are buffered and not be reported (there's a special case for ambiguity errors for some reason: those are force to the reporter when context.ambiguousErrors, or else they are buffered -- TODO: can we simplify this?)

   When using the type checker after typers, an error results in a TypeError being thrown. TODO: get rid of this mode.

   To handle nested contexts, reporters share buffers. TODO: only buffer in BufferingReporter, emit immediately in ImmediateReporter

3. #### trait ImportContext extends Analyzer.Context

   A `Context` focussed on an `Import` tree

4. #### class ImportInfo extends AnyRef

5. #### type ImportType = Global.ImportType

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Contexts to any2stringadd[Contexts] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Contexts, B)

   Implicit information
     This member is added by an implicit conversion from Contexts to ArrowAssoc[Contexts] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val ImportType: Global.ImportType.type

7. #### object NoContext extends Analyzer.Context

8. #### def ambiguousDefnAndImport(owner: Global.Symbol, imp: Analyzer.ImportInfo): Global.LookupAmbiguous

9. #### def ambiguousImports(imp1: Analyzer.ImportInfo, imp2: Analyzer.ImportInfo): Global.LookupAmbiguous

10. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def ensuring(cond: (Contexts) ⇒ Boolean, msg: ⇒ Any): Contexts

    Implicit information
      This member is added by an implicit conversion from Contexts to Ensuring[Contexts] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (Contexts) ⇒ Boolean): Contexts

    Implicit information
      This member is added by an implicit conversion from Contexts to Ensuring[Contexts] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): Contexts

    Implicit information
      This member is added by an implicit conversion from Contexts to Ensuring[Contexts] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): Contexts

    Implicit information
      This member is added by an implicit conversion from Contexts to Ensuring[Contexts] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Contexts to StringFormat[Contexts] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

20. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### var lastAccessCheckDetails: String

23. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

24. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

25. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

26. #### def onTreeCheckerError(pos: Global.Position, msg: String): Unit

    Attributes
      protected

27. #### def resetContexts(): Unit

28. #### def rootContext(unit: Global.CompilationUnit, tree: Global.Tree = EmptyTree, throwing: Boolean = false, checking: Boolean = false): Analyzer.Context

29. #### def rootContextPostTyper(unit: Global.CompilationUnit, tree: Global.Tree = EmptyTree): Analyzer.Context

30. #### def rootImports(unit: Global.CompilationUnit): List[Global.Symbol]

    List of symbols to import from in a root context.

    List of symbols to import from in a root context. Typically that is `java.lang`, `scala`, and scala.Predef, in that order. Exceptions:

    - if option `-Yno-imports` is given, nothing is imported
    - if the unit is java defined, only `java.lang` is imported
    - if option `-Yno-predef` is given, if the unit body has an import of Predef among its leading imports, or if the tree is scala.Predef, `Predef` is not imported.
    Attributes
      protected

31. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

32. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

33. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### def warnUnusedImports(unit: Global.CompilationUnit): Unit

37. #### def →[B](y: B): (Contexts, B)

    Implicit information
      This member is added by an implicit conversion from Contexts to ArrowAssoc[Contexts] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Contexts to any2stringadd[Contexts]

### Inherited by implicit conversion StringFormat from Contexts to StringFormat[Contexts]

### Inherited by implicit conversion Ensuring from Contexts to Ensuring[Contexts]

### Inherited by implicit conversion ArrowAssoc from Contexts to ArrowAssoc[Contexts]

### Ungrouped